int rc_gridGenerated = 0;
int rc_points = 0;
float rc_timeLimit = 120.0;
float rc_startTime;
float rc_endtime;
int secondsLeft;
int freeBlocks = 0;
int blocksAvaiable = 0;
bool isRefilling = false;
bool raged = false;
int minesMax = 32;
int mines = 0;
bool bonusOver = false;
int minesExploded = 0;
int nonMinesTouched = 0;
int bonusRoundReq = 3000;


array<array<int>> gridmap(16, array<int>(16));
//								yellow	white	orange	red		pink	purple	green	blue	random	expl	rage
array<int> blockCountMax =		{ 64,	55,		50,		32,		18,		8,		8,		8,		8,		8,		1 };
array<int> blockCount =			{ 0,	0,		0,		0,		0,		0,		0,		0,	 	0,		0,		0 };		// 2000 points max
array<int> blockPoints =		{ 5,	0,		10,		20,		50,		-50,	0,		0,	 	0,		0,		0 };		// 2000 points max

HUDTextParams hudScore;
HUDTextParams hudRage1;
HUDTextParams hudRage2;
HUDTextParams hudRage3;

enum blocktype
{
	yellow = 0,
	white,
	orange,
	red,
	pink,
	purple,
	green,
	blue,
	random,
	explosive,
	rage,		// 10
	flag,
	grey,
	minegrey,
	minered,
	one,
	two,
	three,
	four,
	five,
	six,		//20
	seven,
	eight,
	empty		//23
};


void Start(CBaseEntity@ pActivator, CBaseEntity@ pCaller, USE_TYPE useType, float flValue)
{
	hudScore.x = 0.05;
	hudScore.y = 0.05;
	hudScore.effect = 0;
	hudScore.r1 = 255;
	hudScore.g1 = 255;
	hudScore.b1 = 255;
	hudScore.a1 = 0;
	hudScore.r2 = 255;
	hudScore.g2 = 255;
	hudScore.b2 = 255;
	hudScore.a2 = 0;	
	hudScore.fadeinTime = 0; 
	hudScore.fadeoutTime = 0;
	hudScore.holdTime = 1.0;
	hudScore.fxTime = 0;
	hudScore.channel = 0;
	
	hudRage1 = hudScore;
	//hudRage1.r1 = 0;
	hudRage1.b1 = 0;
	hudRage1.r2 = 0;
	hudRage1.b2 = 0;
	hudRage1.fadeinTime = 1;
	hudRage1.fadeoutTime = 1;
	hudRage1.holdTime = 2;
	hudRage1.channel = 1;
	hudRage1.x = Math.RandomFloat( 0.1, 0.9 );
	hudRage1.y = Math.RandomFloat( 0.1, 0.9 );
	
	hudRage2 = hudRage1;
	hudRage2.channel = 2;
	hudRage1.fadeinTime = 2;
	hudRage2.x = Math.RandomFloat( 0.1, 0.9 );
	hudRage2.y = Math.RandomFloat( 0.1, 0.9 );
	
	hudRage3 = hudRage1;
	hudRage3.channel = 3;
	hudRage1.fadeinTime = 3;
	hudRage3.x = Math.RandomFloat( 0.1, 0.9 );
	hudRage3.y = Math.RandomFloat( 0.1, 0.9 );

	ResetGrid();
	GenerateGridMap();
	//g_Game.AlertMessage( at_console, "triggered hard \n" );
}

void ResetGrid()
{
	for( int i = 0; i < 16; i++ )
	{
		for( int j = 0; j < 16; j++ )
		{
			gridmap[i][j] = empty;
			string blockName = "rc_" + i + "_" + j;
			CBaseEntity@ eBlock = g_EntityFuncs.FindEntityByTargetname(null, blockName);
			
			if( eBlock !is null)
			{
				g_EntityFuncs.Remove( eBlock );
			}
		}
	}
	
	blockCount[0] = 0;
	blockCount[1] = 0;
	blockCount[2] = 0;
	blockCount[3] = 0;
	blockCount[4] = 0;
	blockCount[5] = 0;
	blockCount[6] = 0;
	blockCount[7] = 0;
	blockCount[8] = 0;
	blockCount[9] = 0;
	blockCount[10] = 0;
	rc_gridGenerated = 0;
	//g_Game.AlertMessage( at_console, "grid reset \n" );
}

void GenerateGridMap()
{
	for( int i = 0; i < 1; i++ )
	{
		int posX = Math.RandomLong(0,15);
		int posY = Math.RandomLong(0,15);
		int iType = Math.RandomLong(0,10);
		
		if( gridmap[posX][posY] == empty && blockCount[iType] < blockCountMax[iType] )
		{
			blockCount[iType]++;
			gridmap[posX][posY] = iType;
			SpawnNewBlock( posX, posY, iType );
			rc_gridGenerated++;
			//g_Game.AlertMessage( at_console, "" + rc_gridGenerated + " of 256 \n" );
		}
		else
		{
			i--;
		}
	}
	
	if( rc_gridGenerated < 256 )
	{
		g_Scheduler.SetTimeout( "GenerateGridMap", 0.05f );
	}
	else
	{
		secondsLeft = 21;
		rc_startTime = g_Engine.time;
		g_EntityFuncs.FireTargets( "rc_music", null, null, USE_TOGGLE);
		g_Scheduler.SetTimeout( "PhaseWarmup", 0.1f );
		//g_Game.AlertMessage( at_console, "done \n" );
	}
}


void GenerateBonusRound()
{
	for( int i = 0; i < 1; i++ )
	{
		int posX = Math.RandomLong(0,15);
		int posY = Math.RandomLong(0,15);
		int isMine = Math.RandomLong(0,10);
		
		if( gridmap[posX][posY] == empty )
		{
			if( isMine >= 9 && mines < minesMax )
			{
				mines++;
				gridmap[posX][posY] = minegrey;
				SpawnNewBlock( posX, posY, minegrey );
				rc_gridGenerated++;
			}
			else
			{
				gridmap[posX][posY] = grey;
				SpawnNewBlock( posX, posY, grey );
				rc_gridGenerated++;
			}
		}
		else
		{
			i--;
		}
	}
	
	if( rc_gridGenerated < 256 )
	{
		g_Scheduler.SetTimeout( "GenerateBonusRound", 0.05f );
	}
	else
	{
		secondsLeft = 11;
		rc_startTime = g_Engine.time;
		CountMines();
		//g_EntityFuncs.FireTargets( "rc_music", null, null, USE_TOGGLE);
		g_Scheduler.SetTimeout( "PhaseBonusWarmup", 0.1f );
		//g_Game.AlertMessage( at_console, "done \n" );
	}
}


void RefillGridMap()
{
	if( freeBlocks > 0 )
	{	
		for( int i = 0; i < 1; i++ )
		{
			int posX = Math.RandomLong(0,15);
			int posY = Math.RandomLong(0,15);
			int iType = Math.RandomLong(0,9);
			
			if( gridmap[posX][posY] == empty && blockCount[iType] < blockCountMax[iType] )
			{
				blockCount[iType]++;
				gridmap[posX][posY] = iType;
				SpawnNewBlock( posX, posY, iType );
				blocksAvaiable--;
				freeBlocks--;
				//g_Game.AlertMessage( at_console, "Refilled Grid \n" );
			}
			else
			{
				i--;
				//g_Game.AlertMessage( at_console, "Cant find empty spot \n" );
			}
		}
	}
	
	if( blocksAvaiable > 0 )
	{
		g_Scheduler.SetTimeout( "RefillGridMap", 0.5f );
	}
	else
	{
		//g_Game.AlertMessage( at_console, "Refilled done \n" );
		isRefilling = false;
	}

}


void CountMines()
{
	for( int i = 0; i < 16; i++ )
	{
		for( int j = 0; j < 16; j++ )
		{
			if( gridmap[i][j] == minegrey )
			{
				//topleft
				if( (i-1) >= 0 && (j+1) <= 15 )
				{
					if( gridmap[i-1][j+1] == grey )
					{
						gridmap[i-1][j+1] = one;
					}
					else if( gridmap[i-1][j+1] >= one )
					{
						gridmap[i-1][j+1] += 1;
					}
				}
				//top
				if( (j+1) <= 15 )
				{
					if( gridmap[i][j+1] == grey )
					{
						gridmap[i][j+1] = one;
					}
					else if( gridmap[i][j+1] >= one )
					{
						gridmap[i][j+1] += 1;
					}
				}
				//topright
				if( (i+1) <= 15 && (j+1) <= 15 )
				{
					if( gridmap[i+1][j+1] == grey )
					{
						gridmap[i+1][j+1] = one;;
					}
					else if( gridmap[i+1][j+1] >= one )
					{
						gridmap[i+1][j+1] += 1;
					}
				}
				//right
				if( (i+1) <= 15 )
				{
					if( gridmap[i+1][j] == grey )
					{
						gridmap[i+1][j] = one;
					}
					else if( gridmap[i+1][j] >= one )
					{
						gridmap[i+1][j] += 1;
					}
				}
				//bottomright
				if( (i+1) <= 15 && (j-1) >= 0 )
				{
					if( gridmap[i+1][j-1] == grey )
					{
						gridmap[i+1][j-1] = one;
					}
					else if( gridmap[i+1][j-1] >= one )
					{
						gridmap[i+1][j-1] += 1;
					}
				}
				//bottom
				if( (j-1) >= 0 )
				{
					if( gridmap[i][j-1] == grey )
					{
						gridmap[i][j-1] = one;
					}
					else if( gridmap[i][j-1] >= one )
					{
						gridmap[i][j-1] += 1;
					}
				}
				//bottomleft
				if( (i-1) >= 0 && (j-1) >= 0 )
				{
					if( gridmap[i-1][j-1] == grey )
					{
						gridmap[i-1][j-1] = one;
					}
					else if( gridmap[i-1][j-1] >= one )
					{
						gridmap[i-1][j-1] += 1;
					}
				}
				//left
				if( (i-1) >= 0 )
				{
					if( gridmap[i-1][j] == grey )
					{
						gridmap[i-1][j] = one;
					}
					else if( gridmap[i-1][j] >= one )
					{
						gridmap[i-1][j] += 1;
					}
				}
			}
		}
	}
}


void SpawnNewBlock( int posX, int posY, int iType )
{
	int iType2 = iType;
	
	string blockName = "rc_" + posX + "_" + posY;

	Vector pos = Vector( -960 + (posX*128), -960 + (posY*128), 0 );
	CBaseEntity@ eBlock = g_EntityFuncs.Create( "rc_block", pos, Vector(0,0,270), true, null );
	
	if( @eBlock !is null )
	{
		g_EntityFuncs.DispatchKeyValue( eBlock.edict(), "targetname", blockName );
		g_EntityFuncs.SetModel( eBlock, "models/ragemap2020/rc_block2020.mdl" );
		
		if( iType == minegrey ){ eBlock.pev.skin = grey; }
		else{ eBlock.pev.skin = iType; }
	
		eBlock.pev.iuser1 = iType;
		g_EntityFuncs.DispatchKeyValue( eBlock.edict(), "posx", posX );
		g_EntityFuncs.DispatchKeyValue( eBlock.edict(), "posy", posY );
		
		g_EntityFuncs.DispatchSpawn( @eBlock.edict() );
	}
}


void BonusLost()
{

}


void PhaseWarmup()
{
	secondsLeft --;
	g_PlayerFuncs.HudMessageAll( hudScore, "Game begins in " + secondsLeft + " seconds.\n");
	
	if( secondsLeft <= 0)
	{
		secondsLeft = 121; //121
		g_EntityFuncs.FireTargets( "rc_wall", null, null, USE_TOGGLE);
		g_Scheduler.SetTimeout( "PhaseActive", 1.0 );
	}
	else
	{
		g_Scheduler.SetTimeout( "PhaseWarmup", 1.0 );
	}
}


void PhaseActive()
{
	secondsLeft --;
	g_PlayerFuncs.HudMessageAll( hudScore, "Game ends in " + secondsLeft + " seconds.\nScore: " + rc_points + "\n");
	
	if( secondsLeft <= 0)
	{
		g_EntityFuncs.FireTargets( "rc_hurt", null, null, USE_TOGGLE);
		freeBlocks = 0;
		blocksAvaiable = 0;
	
		if( raged )
		{
			g_EntityFuncs.FireTargets( "rc_light", null, null, USE_TOGGLE);
			g_EntityFuncs.FireTargets( "rc_light2", null, null, USE_TOGGLE);
		}
	
		if( rc_points <= bonusRoundReq ) //2500
		{
			secondsLeft = 11;
			g_EntityFuncs.FireTargets( "rc_door_exit", null, null, USE_TOGGLE);
			g_EntityFuncs.FireTargets( "rc_wall", null, null, USE_TOGGLE);
			g_PlayerFuncs.RespawnAllPlayers( true, true );
			g_Scheduler.SetTimeout( "End", 1.0 );
			rc_endtime = g_Engine.time;
		}
		else
		{
			ResetGrid();
			GenerateBonusRound();
			secondsLeft = 11;
			g_EntityFuncs.FireTargets( "rc_wall", null, null, USE_TOGGLE);
			g_PlayerFuncs.RespawnAllPlayers( true, true );
		}
	}
	else
	{
		g_Scheduler.SetTimeout( "PhaseActive", 1.0 );
	}
}


void PhaseBonusWarmup()
{
	secondsLeft --;
	
	g_PlayerFuncs.HudMessageAll( hudScore, "Score over " + bonusRoundReq + ": Bonus round starts in " + secondsLeft + " seconds.\nScore: " + rc_points + "\n");

	if( secondsLeft <= 0)
	{
		secondsLeft = 301;
		g_EntityFuncs.FireTargets( "rc_wall", null, null, USE_TOGGLE);
		g_Scheduler.SetTimeout( "PhaseBonus", 1.0 );
	}
	else
	{
		g_Scheduler.SetTimeout( "PhaseBonusWarmup", 1.0 );
	}
}


void PhaseBonus()
{
	g_PlayerFuncs.HudMessageAll( hudScore, "Explore! \nDo not blow more than 4 mines. \nMines exploded: " + minesExploded + "/4 \n");

	if( minesExploded <= 4 && nonMinesTouched < 224 )
	{
		g_Scheduler.SetTimeout( "PhaseBonus", 1.0 );
	}
	else
	{
		secondsLeft = 11;
		g_EntityFuncs.FireTargets( "rc_door_exit", null, null, USE_TOGGLE);
		g_EntityFuncs.FireTargets( "rc_wall", null, null, USE_TOGGLE);
		g_PlayerFuncs.RespawnAllPlayers( true, true );
		End();
	}
}

void End()
{
	secondsLeft --;
	
	if( minesExploded <= 4 && rc_points >= bonusRoundReq )
	{
		g_PlayerFuncs.HudMessageAll( hudScore, "Game ended. \nScore: " + rc_points + "\nBonus round won!");
	}
	else if( rc_points >= bonusRoundReq )
	{
		g_PlayerFuncs.HudMessageAll( hudScore, "Game ended. \nScore: " + rc_points + "\nBonus round lost.");
	}
	else
	{
		g_PlayerFuncs.HudMessageAll( hudScore, "Game ended. Score too low for bonus round. \nScore: " + rc_points + "\n");
	}
	
	if( secondsLeft > 0)
	{
		g_Scheduler.SetTimeout( "End", 1.0 );
	}
	else
	{
		ResetGrid();
	}
}


class rc_block : ScriptBaseEntity
{
	int iBlockType;
	int posX;
	int posY;
	float fDelay = 0.8;
	float spawnTime;
	bool markedDead = false;
		
	void Spawn()
	{ 
		Precache();
		
		g_EntityFuncs.SetModel( self, "models/ragemap2020/rc_block2020.mdl" );
		g_EntityFuncs.SetSize( pev, Vector(-64, -64, -64), Vector(64, 64, 64) );
		self.pev.solid			= SOLID_BBOX;
		self.pev.movetype		= MOVETYPE_NONE;
		self.pev.rendermode 	= kRenderTransAlpha;
		self.pev.renderamt 		= 0;
		self.pev.sequence		= 0;
		self.pev.frame			= 0;
		g_EntityFuncs.SetOrigin( self, self.pev.origin );
		self.pev.takedamage		= DAMAGE_AIM;

		spawnTime = g_Engine.time;
		te_beamdisk();

		SetThink( ThinkFunction( this.Think ) );	
		self.pev.nextthink	= g_Engine.time + 0.1;
		
		//g_Game.AlertMessage( at_console, "block '" + self.pev.targetname + "' created at " + posX + "|" + posY + " of type " + self.pev.iuser1 + "\n" );
	}
	
	
	void Precache()
	{
		g_Game.PrecacheModel( "models/ragemap2020/rc_block2020.mdl" );
		g_Game.PrecacheModel( "sprites/laserbeam.spr" );
		g_SoundSystem.PrecacheSound( "ragemap2020/rc_block_spawn.wav" );
		g_SoundSystem.PrecacheSound( "ragemap2020/rc_block_die.wav" );
		g_SoundSystem.PrecacheSound( "ragemap2020/rc_block_touch.wav" );
		
		g_Game.PrecacheModel( "sprites/ragemap2020/rc/yellow.spr" );
		g_Game.PrecacheModel( "sprites/ragemap2020/rc/orange.spr" );
		g_Game.PrecacheModel( "sprites/ragemap2020/rc/red.spr" );
		g_Game.PrecacheModel( "sprites/ragemap2020/rc/pink.spr" );
		g_Game.PrecacheModel( "sprites/ragemap2020/rc/purple.spr" );
		g_Game.PrecacheModel( "sprites/ragemap2020/rc/green.spr" );
		g_Game.PrecacheModel( "sprites/ragemap2020/rc/blue.spr" );
		g_Game.PrecacheModel( "sprites/ragemap2020/rc/random.spr" );
		g_Game.PrecacheModel( "sprites/ragemap2020/rc/explosive.spr" );
		g_Game.PrecacheModel( "sprites/ragemap2020/rc/rage.spr" );
		
		g_Game.PrecacheModel( "sprites/ragemap2020/rc/rc_explosion2HD.spr" );
		g_Game.PrecacheModel( "sprites/ragemap2020/rc/rc_explosionHD.spr" );
	}
	
	
	bool KeyValue( const string& in szKey, const string& in szValue )
	{
		if(szKey == "type")
		{
			iBlockType = atoi( szValue );
			return true;
		}
		else if(szKey == "posx")
		{
			posX = atoi( szValue );
			return true;
		}
		else if(szKey == "posy")
		{
			posY = atoi( szValue );
			return true;
		}
		else
			return BaseClass.KeyValue( szKey, szValue );
	}


	void Initialize()
	{
		self.pev.rendermode 	= kRenderNormal;
		self.pev.renderamt 		= 255;
		self.pev.solid			= SOLID_BBOX;
		g_SoundSystem.EmitSoundDyn( self.edict(), CHAN_AUTO, "ragemap2020/rc_block_spawn.wav", 1, 0.3f, 0, Math.RandomLong(60,140) );
	}
	
	
	void Think()
	{
		if( g_Engine.time >= ( spawnTime + fDelay ) )
		{
			Initialize();
		}
		else
		{
			self.pev.nextthink = g_Engine.time + 0.1;
		}
	}


	void Touch( CBaseEntity@ pOther )
	{
		
		if( pOther !is null && pOther.IsPlayer() )
		{			
			if( !markedDead )
			{
				if( pOther.pev.origin.z > self.pev.origin.z + 48 )
				{
					if( self.pev.iuser1 == random )
					{
						self.pev.iuser1 = Math.RandomLong(0,7);
						
						if( self.pev.iuser1 == 7 )
						{
							 self.pev.iuser1 = 9;
						}
					}
					
					CBasePlayer@ pPlayer = cast<CBasePlayer@>( pOther );
					
					if( self.pev.iuser1 <= purple )
					{
						pPlayer.AddPoints( blockPoints[self.pev.iuser1], true );
					}
					else if( self.pev.iuser1 == green && self.pev.iuser1 == rage )
					{
						pPlayer.AddPoints( -100, true );
					}
					
					TakeDamage( self.pev, self.pev, 1000, DMG_FALL );
				}
			}
		}
	}
	
	
	void Death()
	{
		if( self.pev.iuser1 != minegrey )
		{
			g_SoundSystem.EmitSoundDyn( self.edict(), CHAN_AUTO, "ragemap2020/rc_block_die.wav", 1, 0.3f, 0, Math.RandomLong(60,140) );
			g_EntityFuncs.Remove( self );
		}
	
	}
	
	
	int TakeDamage(entvars_t@ pevInflictor, entvars_t@ pevAttacker, float flDamage, int bitsDamageType)
	{
		//g_Game.AlertMessage( at_console, "touched: " + posX + ", " + posY + "\n" );
	
		if( bitsDamageType == DMG_FALL )
		{
			if( self.pev.iuser1 <= rage && !markedDead )
			{
				g_SoundSystem.EmitSoundDyn( self.edict(), CHAN_AUTO, "ragemap2020/rc_block_touch.wav", 1, 0.3f, 0, Math.RandomLong(60,140) );
				markedDead = true;
				freeBlocks++;
				blockCount[self.pev.iuser1]--;
				gridmap[posX][posY] = 23;
				te_beamdisk();
				te_bubbles();
				
				if( self.pev.iuser1 == explosive ){ rc_explosion(); }
				else if( self.pev.iuser1 == blue )
				{
					blocksAvaiable += 5;

					if( !isRefilling )
					{
						isRefilling = true;
						g_Scheduler.SetTimeout( "RefillGridMap", 0.5f );
					}
				}
				else if( self.pev.iuser1 == green )
				{
					g_EntityFuncs.FireTargets( "rc_monster", null, null, USE_TOGGLE);
				}
				else if( self.pev.iuser1 == rage )
				{
					raged = true;
					g_EntityFuncs.FireTargets( "rc_shake", null, null, USE_TOGGLE);
					g_EntityFuncs.FireTargets( "rc_light", null, null, USE_TOGGLE);
					g_EntityFuncs.FireTargets( "rc_light2", null, null, USE_TOGGLE);
					g_PlayerFuncs.HudMessageAll( hudRage1, "You fuckin idiot!\n");
					g_PlayerFuncs.HudMessageAll( hudRage2, "Why do you touch the ragecube ?!\n");
					g_PlayerFuncs.HudMessageAll( hudRage3, "Voteban that retard!\n");
				}
				
				rc_points += blockPoints[self.pev.iuser1];
				
				SetThink( ThinkFunction( this.Death ) );	
				self.pev.nextthink	= g_Engine.time + 0.2;
				
				return 0;
			}
			// special touch for bonus blocks
			else if( !markedDead )
			{
				g_SoundSystem.EmitSoundDyn( self.edict(), CHAN_AUTO, "ragemap2020/rc_block_touch.wav", 1, 0.3f, 0, Math.RandomLong(60,140) );
				markedDead = true;
				te_beamdisk();
				
				if( self.pev.iuser1 == minegrey && self.pev.skin != flag )
				{
					minesExploded++;
					self.pev.skin = minered;
					rc_explosion();
					BonusLost();
					SetThink( ThinkFunction( this.Death ) );	
					self.pev.nextthink	= g_Engine.time + 0.5;
					return 0;	
				}
				else if( gridmap[posX][posY] >= one && gridmap[posX][posY] != empty )
				{
					nonMinesTouched++;
					//g_Game.AlertMessage( at_console, "One or higher touched \n" );
					self.pev.skin = gridmap[posX][posY];
				}
				else if( gridmap[posX][posY] == grey )
				{
					nonMinesTouched++;
					self.pev.origin.z = -8;
					//g_Game.AlertMessage( at_console, "grey touched \n" );
				}
			}
			
		}
		else if( gridmap[posX][posY] >= grey && gridmap[posX][posY] != empty )
		{
			if( self.pev.skin == flag ){ self.pev.skin = grey; }
			else if( self.pev.skin == grey ){ self.pev.skin = flag; }
			markedDead = false;
		}
		
		return 1;
	}

	
	void te_beamdisk()
	{
		Color c;
		if( self.pev.iuser1 == yellow ){ 			c = YELLOW; }
		else if( self.pev.iuser1 == orange ){ 		c = ORANGE; }
		else if( self.pev.iuser1 == red ){ 			c = RED; }
		else if( self.pev.iuser1 == pink ){ 		c = PINK; }
		else if( self.pev.iuser1 == purple ){ 		c = PURPLE; }
		else if( self.pev.iuser1 == green ){ 		c = GREEN; }
		else if( self.pev.iuser1 == blue ){ 		c = BLUE; }
		else if( self.pev.iuser1 == rage ){ 		c = ORANGE; }
		else if( self.pev.iuser1 == random ){ 		c = BLUE; }
		else if( self.pev.iuser1 == explosive ){ 	c = ORANGE; }
		else{ 										c = WHITE; }
	
		NetworkMessage m( MSG_BROADCAST, NetworkMessages::SVC_TEMPENTITY, null );
		m.WriteByte( TE_BEAMDISK );
		m.WriteCoord( self.pev.origin.x );
		m.WriteCoord( self.pev.origin.y );
		m.WriteCoord( self.pev.origin.z + 64 );
		m.WriteCoord( self.pev.origin.x );
		m.WriteCoord( self.pev.origin.y );
		m.WriteCoord( self.pev.origin.z + 128 );
		m.WriteShort( g_EngineFuncs.ModelIndex("sprites/laserbeam.spr") );
		m.WriteByte( 0 );
		m.WriteByte( 32 );
		m.WriteByte( 16 );
		m.WriteByte( 1 );
		m.WriteByte( 0 );
		m.WriteByte(c.r);
		m.WriteByte(c.g);
		m.WriteByte(c.b);
		m.WriteByte(c.a);
		m.WriteByte( 0 );
		m.End();
	}
	
	
	void te_bubbles()
	{
		string sprite;
		if( self.pev.iuser1 == yellow ){ 			sprite = "sprites/ragemap2020/rc/yellow.spr"; }
		else if( self.pev.iuser1 == orange ){ 		sprite = "sprites/ragemap2020/rc/orange.spr"; }
		else if( self.pev.iuser1 == red ){ 			sprite = "sprites/ragemap2020/rc/red.spr"; }
		else if( self.pev.iuser1 == pink ){ 		sprite = "sprites/ragemap2020/rc/pink.spr"; }
		else if( self.pev.iuser1 == purple ){ 		sprite = "sprites/ragemap2020/rc/purple.spr"; }
		else if( self.pev.iuser1 == green ){ 		sprite = "sprites/ragemap2020/rc/green.spr"; }
		else if( self.pev.iuser1 == blue ){ 		sprite = "sprites/ragemap2020/rc/blue.spr"; }
		else if( self.pev.iuser1 == rage ){ 		sprite = "sprites/ragemap2020/rc/rage.spr"; }
		else if( self.pev.iuser1 == random ){ 		sprite = "sprites/ragemap2020/rc/random.spr"; }
		else if( self.pev.iuser1 == explosive ){ 	sprite = "sprites/ragemap2020/rc/explosive.spr"; }
		else{ 										sprite = ""; }
	
		NetworkMessage m( MSG_BROADCAST, NetworkMessages::SVC_TEMPENTITY, null );
		m.WriteByte( TE_BUBBLES );
		m.WriteCoord( self.pev.absmin.x );
		m.WriteCoord( self.pev.absmin.y );
		m.WriteCoord( self.pev.absmin.z );
		m.WriteCoord( self.pev.absmax.x );
		m.WriteCoord( self.pev.absmax.y );
		m.WriteCoord( self.pev.absmax.z );
		m.WriteCoord( 256 );
		m.WriteShort( g_EngineFuncs.ModelIndex(sprite) );
		m.WriteByte( 8 );
		m.WriteCoord( 16 );
		m.End();
	}
	
	
	void te_explosion(Vector pos, string sprite, int scale, int frameRate, int flags)
	{
		NetworkMessage m( MSG_BROADCAST, NetworkMessages::SVC_TEMPENTITY, null );
		m.WriteByte( TE_EXPLOSION);
		m.WriteCoord( pos.x );
		m.WriteCoord( pos.y );
		m.WriteCoord( pos.z );
		m.WriteShort( g_EngineFuncs.ModelIndex(sprite) );
		m.WriteByte( scale );
		m.WriteByte( frameRate );
		m.WriteByte( flags );
		m.End();
	}
	
	
	void rc_explosion()
	{
		g_WeaponFuncs.RadiusDamage( self.pev.origin, self.pev, self.pev, 250, 500, CLASS_NONE, DMG_FALL );
		
		string explosionSprite = "sprites/ragemap2020/rc/rc_explosionHD.spr";
		string explosionSprite2 = "sprites/ragemap2020/rc/rc_explosion2HD.spr";
		
		Vector explosionPos1 = self.pev.origin + (g_Engine.v_up * 32);
		Vector explosionPos2 = self.pev.origin;
		
		te_explosion(explosionPos1, explosionSprite, 10, 20, 0);
		te_explosion(explosionPos2, explosionSprite2, 10, 20, 0);
	}
	
}


class Color
{ 
	uint8 r, g, b, a;
	
	Color() { r = g = b = a = 0; }
	Color(uint8 _r, uint8 _g, uint8 _b, uint8 _a = 255 ) { r = _r; g = _g; b = _b; a = _a; }
	Color (Vector v) { r = int(v.x); g = int(v.y); b = int(v.z); a = 255; }
	string ToString() { return "" + r + " " + g + " " + b + " " + a; }
}

const Color RED(255,0,0);
const Color GREEN(0,255,0);
const Color BLUE(0,0,255);
const Color YELLOW(255,255,0);
const Color ORANGE(255,127,0);
const Color PURPLE(127,0,255);
const Color PINK(255,0,127);
const Color TEAL(0,255,255);
const Color WHITE(255,255,255);
const Color BLACK(0,0,0);
const Color GRAY(127,127,127);